<template>
  <div>
    <q-table
      title="Daftar Banner"
      class="table-produk-saya"
      :data="data"
      :columns="columns"
      row-key="id"
      :pagination.sync="pagination"
      :loading="loading"
      :filter="filter"
      @request="onRequest"
      binary-state-sort
    >
      <template v-slot:top-right style="color: white !important;">
        <q-input borderless dense debounce="300" v-model="filter" placeholder="Cari Produk" @input="onRequest" color="white">
          <template v-slot:append style="color: white">
            <q-icon name="search"  />
          </template>
        </q-input>
      </template>

      <template v-slot:body="props">
        <q-tr :props="props" :key="`m_${props.row.index}`">
          <q-td
            style="width: 30px"
            key="index"
          >
            {{ props.row.index }}.
          </q-td>
          <q-td style="text-align: center">
            Banner Jarkons
          </q-td>
          <q-td style="width: 150px; text-align: center"> Want to Join On Jarkons? </q-td>
          <q-td style="width: 150px" > https://dev.jarkons.com</q-td>
          <q-td style="width: 150px; text-align: center" >
            <q-btn
              size="10px"
              rounded
              color="grey"
              label="Publis"
            />
          </q-td>

          <q-td style="width: 150px; text-align: center"> 28-01-2020 s/d 10-02-2020 </q-td>
          <q-td style="width: 150px; text-align: center">06-03-2020 15:14:11  </q-td>

          <q-td key="actions" :props="props" style="padding-left: 0; padding-right: 0">
            <q-btn style="margin-right: 5px" size="10px" color="orange" >Edit</q-btn>
            <q-btn style="margin-right: 5px" size="10px" color="red" >Hapus</q-btn>
            <q-btn style="margin-right: 5px" size="10px" color="grey" >Unpublis</q-btn>
          </q-td>
        </q-tr>
      </template>
    </q-table>
  </div>
</template>

<script>
  export default {
    data () {
      return {
        filter: '',
        loading: false,
        token: localStorage.getItem("token"),
        pagination: {
          sortBy: 'index',
          descending: true,
          page: 1,
          rowsPerPage: 5,
          rowsNumber: 10
        },
        columns: [
          {
            name: 'index',
            required: true,
            label: 'No',
            align: 'left',
            field: 'index',
            format: val => `${val}`,
            sortable: true
          },
          { name: 'name_product', align: 'center', label: 'Judul Banner', sortable: true },
          { name: 'product_type', align: 'center', label: 'Deskripsi',
            sortable: true},
          { name: 'product_category', align: 'center', label: 'Target URL', field: 'product_category',
            sortable: true },
          { name: 'price', align: 'center', label: 'Status', sortable: true },
          { name: 'status', align: 'center', label: 'Masa Berlaku', sortable: true },
          { name: 'status', align: 'center', label: 'Last Update', field: 'Last Update', sortable: true },
          { name: 'actions', align: 'center', label: 'Aksi', sortable: true },
        ],
        data: [],
      }
    },
    mounted () {
      // get initial data from server (1st page)
      this.onRequest({
        pagination: this.pagination,
        filter: undefined
      })
    },
    methods: {
      showImage(val) {
        this.$q.dialog({
          message: `<img src="${val}" />`,
          html: true,
        })
      },
      onRequest (props) {
        console.log("props", props);

        const { descending, page, rowsNumber, rowsPerPage, sortBy } = props.pagination;
        const filter = props.filter

        if (! descending) {
          this.pagination.descending = true
        }

        this.loading = true
        let apiUrl =
          `api/product/list?page=${page}&perPage=${rowsPerPage}&sortBy=${sortBy}&filter=${filter}&descending=${descending}`

        let config = {
          method: "get",
          url: apiUrl ,
          headers: {
            Authorization: "Bearer " + this.token
          }
        }

        this.$axios(config)
          .then(response => {

            let data = response.data

            this.data = data.data

            this.data.forEach((row, index) => {
              row.index = index + 1 + ((page-1)*rowsPerPage)
            })

            this.pagination = {
              sortBy: 'index',
              descending: descending,
              page: data.current_page,
              rowsPerPage: data.per_page,
              rowsNumber: data.total
            }

          })
          .catch(error => {
            console.log(error)
          })
          .then(always => {
            this.loading = false
          })
      },
    }
  }
</script>

<style lang="sass" scoped>
  .q-table--no-wrap td
    white-space: normal

    .table-produk-saya

      .q-table__top,
      .q-table__bottom,
      thead tr:first-child th
        /* bg color is important for th; just specify one */
        background-color: #009688
        color: white
        font-size: 16px

      thead tr th
        position: sticky
        z-index: 1
      thead tr:first-child th
        top: 0

      /* this is when the loading indicator appears */
      &.q-table--loading thead tr:last-child th
        /* height of all previous header rows */
        top: 48px
</style>

<style>
thead {
  background-color: #c2c2c2;
}

.q-table__title {
  font-weight: bold;
}

</style>
